# ncurses 6.1 - patch 20180217 - Thomas E. Dickey
#
# ------------------------------------------------------------------------------
#
# Ncurses 6.1 is at
# 	ftp.gnu.org:/pub/gnu
#
# Patches for ncurses 6.1 can be found at
# 	ftp://ftp.invisible-island.net/ncurses/6.1
#	http://invisible-mirror.net/archives/ncurses/6.1 
#
# ------------------------------------------------------------------------------
# ftp://ftp.invisible-island.net/ncurses/6.1/ncurses-6.1-20180217.patch.gz
# patch by Thomas E. Dickey <dickey@invisible-island.net>
# created  Sun Feb 18 01:45:21 UTC 2018
# ------------------------------------------------------------------------------
# NEWS                             |    9 ++++++++-
# VERSION                          |    2 +-
# dist.mk                          |    4 ++--
# man/user_caps.5                  |    4 ++--
# ncurses/base/safe_sprintf.c      |    8 ++------
# ncurses/tinfo/lib_setup.c        |    6 ++----
# ncurses/tinfo/write_entry.c      |    6 +++---
# package/debian-mingw/changelog   |    4 ++--
# package/debian-mingw64/changelog |    4 ++--
# package/debian/changelog         |    4 ++--
# package/debian/rules             |    2 +-
# package/mingw-ncurses.nsi        |    4 ++--
# package/mingw-ncurses.spec       |    2 +-
# package/ncurses.spec             |    2 +-
# test/demo_defkey.c               |    8 ++++----
# test/list_keys.c                 |    6 +++---
# test/picsmap.c                   |   10 +++++-----
# 17 files changed, 43 insertions(+), 42 deletions(-)
# ------------------------------------------------------------------------------
Index: NEWS
Prereq:  1.3080 
--- ncurses-6.1-20180210+/NEWS	2018-02-10 20:36:21.000000000 +0000
+++ ncurses-6.1-20180217/NEWS	2018-02-17 21:27:10.000000000 +0000
@@ -25,7 +25,7 @@
 -- sale, use or other dealings in this Software without prior written        --
 -- authorization.                                                            --
 -------------------------------------------------------------------------------
--- $Id: NEWS,v 1.3080 2018/02/10 20:36:21 tom Exp $
+-- $Id: NEWS,v 1.3085 2018/02/17 21:27:10 tom Exp $
 -------------------------------------------------------------------------------
 
 This is a log of changes that ncurses has gone through since Zeyd started
@@ -45,6 +45,13 @@
 Changes through 1.9.9e did not credit all contributions;
 it is not possible to add this information.
 
+20180217
+	+ remove incorrect free() from 20170617 changes (report by David Macek).
+	+ correct type for "U8" in user_caps.5; it is a number not boolean.
+	+ add a null-pointer check in safe_sprintf.c (report by Steven Noonan).
+	+ improve fix for Debian #882620 by reusing limit2 variable (report
+	  Julien Cristau, Sven Cristau).
+
 20180210
 	+ modify misc/Makefile.in to install/uninstall explicit list in case
 	  the build-directory happens to have no ".pc" files when an uninstall
Index: VERSION
--- ncurses-6.1-20180210+/VERSION	2018-02-10 13:15:08.000000000 +0000
+++ ncurses-6.1-20180217/VERSION	2018-02-11 20:16:59.000000000 +0000
@@ -1 +1 @@
-5:0:10	6.1	20180210
+5:0:10	6.1	20180217
Index: dist.mk
Prereq:  1.1210 
--- ncurses-6.1-20180210+/dist.mk	2018-02-10 13:15:08.000000000 +0000
+++ ncurses-6.1-20180217/dist.mk	2018-02-11 20:16:59.000000000 +0000
@@ -25,7 +25,7 @@
 # use or other dealings in this Software without prior written               #
 # authorization.                                                             #
 ##############################################################################
-# $Id: dist.mk,v 1.1210 2018/02/10 13:15:08 tom Exp $
+# $Id: dist.mk,v 1.1211 2018/02/11 20:16:59 tom Exp $
 # Makefile for creating ncurses distributions.
 #
 # This only needs to be used directly as a makefile by developers, but
@@ -37,7 +37,7 @@
 # These define the major/minor/patch versions of ncurses.
 NCURSES_MAJOR = 6
 NCURSES_MINOR = 1
-NCURSES_PATCH = 20180210
+NCURSES_PATCH = 20180217
 
 # We don't append the patch to the version, since this only applies to releases
 VERSION = $(NCURSES_MAJOR).$(NCURSES_MINOR)
Index: man/user_caps.5
Prereq:  1.6 
--- ncurses-6.1-20180210+/man/user_caps.5	2018-02-03 22:38:17.000000000 +0000
+++ ncurses-6.1-20180217/man/user_caps.5	2018-02-17 19:07:01.000000000 +0000
@@ -26,7 +26,7 @@
 .\" authorization.                                                           *
 .\"***************************************************************************
 .\"
-.\" $Id: user_caps.5,v 1.6 2018/02/03 22:38:17 tom Exp $
+.\" $Id: user_caps.5,v 1.7 2018/02/17 19:07:01 tom Exp $
 .TH user_caps 5
 .ie \n(.g .ds `` \(lq
 .el       .ds `` ``
@@ -211,7 +211,7 @@
 to represent the standard eight ANSI colors, i.e., one bit per color.
 .TP 3
 U8
-\fIboolean\fP,
+\fInumber\fP,
 asserts that ncurses must use Unicode values for line-drawing characters,
 and that it should ignore the alternate character set capabilities
 when the locale uses UTF-8 encoding.
Index: ncurses/base/safe_sprintf.c
Prereq:  1.29 
--- ncurses-6.1-20180210+/ncurses/base/safe_sprintf.c	2018-02-10 17:52:19.000000000 +0000
+++ ncurses-6.1-20180217/ncurses/base/safe_sprintf.c	2018-02-17 21:19:41.000000000 +0000
@@ -33,7 +33,7 @@
 #include <curses.priv.h>
 #include <ctype.h>
 
-MODULE_ID("$Id: safe_sprintf.c,v 1.29 2018/02/10 17:52:19 tom Exp $")
+MODULE_ID("$Id: safe_sprintf.c,v 1.31 2018/02/17 21:19:41 tom Exp $")
 
 #if USE_SAFE_SPRINTF
 
@@ -224,11 +224,7 @@
 {
     char *result = 0;
 
-#if NCURSES_SP_FUNCS
-    (void) sp;
-#endif
-
-    if (fmt != 0) {
+    if (SP_PARM != 0 && fmt != 0) {
 #if USE_SAFE_SPRINTF
 	va_list ap2;
 	int len;
Index: ncurses/tinfo/lib_setup.c
Prereq:  1.188 
--- ncurses-6.1-20180210+/ncurses/tinfo/lib_setup.c	2017-07-01 18:24:50.000000000 +0000
+++ ncurses-6.1-20180217/ncurses/tinfo/lib_setup.c	2018-02-17 21:23:32.000000000 +0000
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2016,2017 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2017,2018 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -48,7 +48,7 @@
 #include <locale.h>
 #endif
 
-MODULE_ID("$Id: lib_setup.c,v 1.188 2017/07/01 18:24:50 tom Exp $")
+MODULE_ID("$Id: lib_setup.c,v 1.189 2018/02/17 21:23:32 tom Exp $")
 
 /****************************************************************************
  *
@@ -722,8 +722,6 @@
 	    termp->Filedes = (short) Filedes;
 	    termp->_termname = strdup(tname);
 	} else {
-	    _nc_free_termtype2(&TerminalType(termp));
-	    free(my_tcb);
 	    ret_error0(errret ? *errret : TGETENT_ERR,
 		       "Could not find any driver to handle this terminal.\n");
 	}
Index: ncurses/tinfo/write_entry.c
Prereq:  1.101 
--- ncurses-6.1-20180210+/ncurses/tinfo/write_entry.c	2017-11-25 19:56:06.000000000 +0000
+++ ncurses-6.1-20180217/ncurses/tinfo/write_entry.c	2018-02-11 20:24:28.000000000 +0000
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 1998-2015,2017 Free Software Foundation, Inc.              *
+ * Copyright (c) 1998-2017,2018 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -50,7 +50,7 @@
 #define TRACE_NUM(n)		/* nothing */
 #endif
 
-MODULE_ID("$Id: write_entry.c,v 1.101 2017/11/25 19:56:06 tom Exp $")
+MODULE_ID("$Id: write_entry.c,v 1.102 2018/02/11 20:24:28 Julien.Cristau Exp $")
 
 static int total_written;
 static int total_parts;
@@ -377,7 +377,7 @@
 	start_time = 0;
     }
 
-    if (strlen(first_name) >= sizeof(filename) - (2 + LEAF_LEN)) {
+    if (strlen(first_name) >= limit2) {
 	_nc_warning("terminal name too long.");
 	saved = first_name[limit2];
 	first_name[limit2] = '\0';
Index: package/debian-mingw/changelog
--- ncurses-6.1-20180210+/package/debian-mingw/changelog	2018-02-10 13:15:08.000000000 +0000
+++ ncurses-6.1-20180217/package/debian-mingw/changelog	2018-02-11 20:16:59.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.1+20180210) unstable; urgency=low
+ncurses6 (6.1+20180217) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 10 Feb 2018 08:15:08 -0500
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 11 Feb 2018 15:16:59 -0500
 
 ncurses6 (5.9-20131005) unstable; urgency=low
 
Index: package/debian-mingw64/changelog
--- ncurses-6.1-20180210+/package/debian-mingw64/changelog	2018-02-10 13:15:08.000000000 +0000
+++ ncurses-6.1-20180217/package/debian-mingw64/changelog	2018-02-11 20:16:59.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.1+20180210) unstable; urgency=low
+ncurses6 (6.1+20180217) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 10 Feb 2018 08:15:08 -0500
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 11 Feb 2018 15:16:59 -0500
 
 ncurses6 (5.9-20131005) unstable; urgency=low
 
Index: package/debian/changelog
--- ncurses-6.1-20180210+/package/debian/changelog	2018-02-10 13:15:08.000000000 +0000
+++ ncurses-6.1-20180217/package/debian/changelog	2018-02-11 20:16:59.000000000 +0000
@@ -1,8 +1,8 @@
-ncurses6 (6.1+20180210) unstable; urgency=low
+ncurses6 (6.1+20180217) unstable; urgency=low
 
   * latest weekly patch
 
- -- Thomas E. Dickey <dickey@invisible-island.net>  Sat, 10 Feb 2018 08:15:08 -0500
+ -- Thomas E. Dickey <dickey@invisible-island.net>  Sun, 11 Feb 2018 15:16:59 -0500
 
 ncurses6 (5.9-20120608) unstable; urgency=low
 
Index: package/debian/rules
--- ncurses-6.1-20180210+/package/debian/rules	2018-02-10 18:25:00.000000000 +0000
+++ ncurses-6.1-20180217/package/debian/rules	2018-02-12 10:19:27.000000000 +0000
@@ -80,7 +80,7 @@
 		--with-develop \
 		--with-extra-suffix=$(MY_ABI) \
 		--with-shared \
-		--with-terminfo-dirs=$(MYDATA):/usr/share/terminfo \
+		--with-terminfo-dirs=$(MYDATA):/lib/terminfo:/usr/share/terminfo \
 		--with-termlib \
 		--with-ticlib \
 		--with-trace \
Index: package/mingw-ncurses.nsi
Prereq:  1.257 
--- ncurses-6.1-20180210+/package/mingw-ncurses.nsi	2018-02-10 13:15:08.000000000 +0000
+++ ncurses-6.1-20180217/package/mingw-ncurses.nsi	2018-02-11 20:16:59.000000000 +0000
@@ -1,4 +1,4 @@
-; $Id: mingw-ncurses.nsi,v 1.257 2018/02/10 13:15:08 tom Exp $
+; $Id: mingw-ncurses.nsi,v 1.258 2018/02/11 20:16:59 tom Exp $
 
 ; TODO add examples
 ; TODO bump ABI to 6
@@ -10,7 +10,7 @@
 !define VERSION_MAJOR "6"
 !define VERSION_MINOR "1"
 !define VERSION_YYYY  "2018"
-!define VERSION_MMDD  "0210"
+!define VERSION_MMDD  "0217"
 !define VERSION_PATCH ${VERSION_YYYY}${VERSION_MMDD}
 
 !define MY_ABI   "5"
Index: package/mingw-ncurses.spec
--- ncurses-6.1-20180210+/package/mingw-ncurses.spec	2018-02-10 18:34:07.000000000 +0000
+++ ncurses-6.1-20180217/package/mingw-ncurses.spec	2018-02-11 20:16:59.000000000 +0000
@@ -3,7 +3,7 @@
 Summary: shared libraries for terminal handling
 Name: mingw32-ncurses6
 Version: 6.1
-Release: 20180210
+Release: 20180217
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{version}-%{release}.tgz
Index: package/ncurses.spec
--- ncurses-6.1-20180210+/package/ncurses.spec	2018-02-10 19:39:45.000000000 +0000
+++ ncurses-6.1-20180217/package/ncurses.spec	2018-02-11 20:16:59.000000000 +0000
@@ -1,7 +1,7 @@
 Summary: shared libraries for terminal handling
 Name: ncurses6
 Version: 6.1
-Release: 20180210
+Release: 20180217
 License: X11
 Group: Development/Libraries
 Source: ncurses-%{version}-%{release}.tgz
Index: test/demo_defkey.c
Prereq:  1.27 
--- ncurses-6.1-20180210+/test/demo_defkey.c	2017-04-09 23:57:56.000000000 +0000
+++ ncurses-6.1-20180217/test/demo_defkey.c	2018-02-12 09:57:31.000000000 +0000
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 2002-2016,2017 Free Software Foundation, Inc.              *
+ * Copyright (c) 2002-2017,2018 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -26,7 +26,7 @@
  * authorization.                                                           *
  ****************************************************************************/
 /*
- * $Id: demo_defkey.c,v 1.27 2017/04/09 23:57:56 tom Exp $
+ * $Id: demo_defkey.c,v 1.28 2018/02/12 09:57:31 tom Exp $
  *
  * Demonstrate the define_key() function.
  * Thomas Dickey - 2002/11/23
@@ -187,9 +187,9 @@
 	const char *prefix = 0;
 	char temp[BUFSIZ];
 
-	if (!strncmp(value, "\033[", (size_t) 2)) {
+	if (!(strncmp) (value, "\033[", (size_t) 2)) {
 	    prefix = "\033O";
-	} else if (!strncmp(value, "\033O", (size_t) 2)) {
+	} else if (!(strncmp) (value, "\033O", (size_t) 2)) {
 	    prefix = "\033[";
 	}
 	if (prefix != 0) {
Index: test/list_keys.c
Prereq:  1.22 
--- ncurses-6.1-20180210+/test/list_keys.c	2017-08-12 17:28:23.000000000 +0000
+++ ncurses-6.1-20180217/test/list_keys.c	2018-02-12 09:57:31.000000000 +0000
@@ -1,5 +1,5 @@
 /****************************************************************************
- * Copyright (c) 2016,2017 Free Software Foundation, Inc.                   *
+ * Copyright (c) 2016-2017,2018 Free Software Foundation, Inc.              *
  *                                                                          *
  * Permission is hereby granted, free of charge, to any person obtaining a  *
  * copy of this software and associated documentation files (the            *
@@ -26,7 +26,7 @@
  * authorization.                                                           *
  ****************************************************************************/
 /*
- * $Id: list_keys.c,v 1.22 2017/08/12 17:28:23 tom Exp $
+ * $Id: list_keys.c,v 1.23 2018/02/12 09:57:31 tom Exp $
  *
  * Author: Thomas E Dickey
  *
@@ -298,7 +298,7 @@
 	Type(j) = ktOther;
 	if (sscanf(strnames[j], "kf%d", &k) == 1) {
 	    Type(j) = ktFunction;
-	} else if (!strncmp(strnames[j], "kcu", 3)) {
+	} else if (!(strncmp) (strnames[j], "kcu", 3)) {
 	    Type(j) = ktCursor;
 	}
 	Name(j) = strnames[j];
Index: test/picsmap.c
Prereq:  1.116 
--- ncurses-6.1-20180210+/test/picsmap.c	2018-01-16 09:14:52.000000000 +0000
+++ ncurses-6.1-20180217/test/picsmap.c	2018-02-12 09:57:31.000000000 +0000
@@ -26,7 +26,7 @@
  * authorization.                                                           *
  ****************************************************************************/
 /*
- * $Id: picsmap.c,v 1.116 2018/01/16 09:14:52 tom Exp $
+ * $Id: picsmap.c,v 1.117 2018/02/12 09:57:31 tom Exp $
  *
  * Author: Thomas E. Dickey
  *
@@ -589,7 +589,7 @@
 		    if (*t == '-') {
 			if (sscanf(t, "-%d%c", &num, &chr) == 2 &&
 			    chr == 'c' &&
-			    !strncmp(strchr(t, chr), "color", 5)) {
+			    !(strncmp) (strchr(t, chr), "color", 5)) {
 			    found = 1;
 			}
 			break;
@@ -597,7 +597,7 @@
 		    ++t;
 		}
 		if (found && (t != s)
-		    && strncmp(s, "xterm", (size_t) (t - s))) {
+		    && (strncmp) (s, "xterm", (size_t) (t - s))) {
 		    sprintf(s, "xterm%s", filename + (t - s));
 		} else {
 		    continue;
@@ -1204,7 +1204,7 @@
 			    /* should not happen... */
 			    continue;
 			}
-			if (!strncmp(cs, list[c], (size_t) cpp)) {
+			if (!(strncmp) (cs, list[c], (size_t) cpp)) {
 			    result->cells[which].ch = list[c][0];
 			    result->cells[which].fg = c;
 			    result->fgcol[c].count++;
@@ -1279,7 +1279,7 @@
 	    size_t n = strlen(filename);
 	    debugmsg2("...read %s", buffer);
 	    if (strlen(buffer) > n &&
-		!strncmp(buffer, filename, n) &&
+		!(strncmp) (buffer, filename, n) &&
 		isspace(UChar(buffer[n])) &&
 		sscanf(skip_word(buffer + n), " %dx%d ", &pic_x, &pic_y) == 2) {
 		/* distort image to make it show normally on terminal */
